<template>
    <div>
        <TableHeader ref="TableHeaderRef">
            <template #select>
                <el-form-item label="用户名称">
                    <el-input
                        style="width: 200px"
                        placeholder="请输入用户名称"
                        v-model="tableStore.table.params.projectName"
                        clearable
                    ></el-input>
                </el-form-item>
                <el-form-item label="所在地市">
                    <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所在地市">
                        <el-option
                            v-for="item in areaOptionList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        ></el-option>
                    </el-select>
                </el-form-item>
            </template>
            <template #operation>
                <el-button icon="el-icon-Plus" type="primary" @click="addFormModel">新增</el-button>
                <el-button icon="el-icon-Download" type="primary" @click="exportExcelTemplate">模板下载</el-button>
                <el-button icon="el-icon-Upload" type="primary" @click="importUserData">批量导入</el-button>
            </template>
        </TableHeader>
        <Table ref="tableRef" />

        <el-dialog title="详情" width="80%" v-model="dialogShow"><DetailInfo :id="userId"></DetailInfo></el-dialog>
        <!-- 批量导入 -->
        <sensitive-user-popup ref="sensitiveUserPopup" />

        <!-- 查看详情 detail 新增/修改 create-->
        <addForm ref="addForms" @onSubmit="tableStore.index()" openType="create"></addForm>
    </div>
</template>
<script setup lang="ts">
import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import addForm from '@/views/pqs/supervise/interfere/components/undocumented/addForm.vue'
import SensitiveUserPopup from './sensitiveUserPopup.vue'
import { useDictData } from '@/stores/dictData'
import { downloadSensitiveReportTemplate } from '@/api/supervision-boot/userReport/form'
import DetailInfo from '../../interfere/components/undocumented/detail.vue'
const addForms = ref()
const dictData = useDictData()
const sensitiveUserPopup = ref()
const TableHeaderRef = ref()
const areaOptionList = dictData.getBasicData('jibei_area')
import { useAdminInfo } from '@/stores/adminInfo'
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getInterferenceUserPage',
    publicHeight: 65,
    method: 'POST',
    column: [
        { title: '序号', type: 'seq', width: 80 },
        { field: 'projectName', title: '用户名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        { field: 'city', title: '所在地市', minWidth: 80 },
        { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        { field: 'substation', title: '变电站', minWidth: 100 },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },

        {
            title: '操作',
            minWidth: 150,
            fixed: 'right',
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '详细信息',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        lookInfo(row.id)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.dataType == 0 || row.dataType == 1)
                    },

                    click: row => {
                        addForms.value.filterUsers([6])
                        addForms.value.open({
                            title: '编辑',
                            row: row
                        })
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
    }
})
tableStore.table.params.city = ''
tableStore.table.params.projectName = ''
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.relationUserName = ''
tableStore.table.params.aisFileUpload = ''

const userId = ref()
const dialogShow = ref(false)

const lookInfo = (id: string) => {
    userId.value = id
    dialogShow.value = true
}

provide('tableStore', tableStore)
onMounted(() => {
    tableStore.index()
})
// 新增
const addFormModel = () => {
    addForms.value.filterUsers([6])

    setTimeout(() => {
        addForms.value.open({
            title: '用户档案录入'
        })
    })
}
/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
//导出模板
const exportExcelTemplate = () => {
    downloadSensitiveReportTemplate().then((res: any) => {
        let blob = new Blob([res], {
            type: 'application/vnd.ms-excel'
        })
        const url = window.URL.createObjectURL(blob)
        const link = document.createElement('a')
        link.href = url
        link.download = '干扰源用户台账模板'
        document.body.appendChild(link)
        link.click()
        link.remove()
    })
}

//批量导入用户数据
const importUserData = () => {
    sensitiveUserPopup.value.open('导入干扰源用户')
}
</script>
